package notary

import (
	"git.frostfs.info/TrueCloudLab/frostfs-node/cmd/frostfs-adm/internal/commonflags"
	"github.com/spf13/cobra"
	"github.com/spf13/viper"
)

var DepositCmd = &cobra.Command{
	Use:   "deposit-notary",
	Short: "Deposit GAS for notary service",
	PreRun: func(cmd *cobra.Command, _ []string) {
		_ = viper.BindPFlag(commonflags.EndpointFlag, cmd.Flags().Lookup(commonflags.EndpointFlag))
	},
	RunE: depositNotary,
}

func initDepositoryNotaryCmd() {
	DepositCmd.Flags().StringP(commonflags.EndpointFlag, commonflags.EndpointFlagShort, "", commonflags.EndpointFlagDesc)
	DepositCmd.Flags().String(commonflags.StorageWalletFlag, "", "Path to storage node wallet")
	DepositCmd.Flags().String(walletAccountFlag, "", "Wallet account address")
	DepositCmd.Flags().String(commonflags.RefillGasAmountFlag, "", "Amount of GAS to deposit")
	DepositCmd.Flags().String(notaryDepositTillFlag, "", "Notary deposit duration in blocks")
}

func init() {
	initDepositoryNotaryCmd()
}
