package object

import (
	"fmt"

	objectSDK "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object"
	oid "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object/id"
)

// AddressWithType groups object address with its FrostFS
// object type.
type AddressWithType struct {
	Address         oid.Address
	Type            objectSDK.Type
	IsLinkingObject bool
}

func (v AddressWithType) String() string {
	return fmt.Sprintf("address: %s, type: %s, is linking: %t", v.Address, v.Type, v.IsLinkingObject)
}
