package metrics

import "time"

type Register interface {
	SetEpoch(epoch uint64)
	SetHealth(s int32)
	AddEvent(d time.Duration, typ string, success bool)
}

type DefaultRegister struct{}

func (DefaultRegister) SetEpoch(uint64)                      {}
func (DefaultRegister) SetHealth(int32)                      {}
func (DefaultRegister) AddEvent(time.Duration, string, bool) {}
