package replicator

import (
	"git.frostfs.info/TrueCloudLab/frostfs-sdk-go/netmap"
	objectSDK "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object"
	oid "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object/id"
)

// Task represents group of Replicator task parameters.
type Task struct {
	// NumCopies is the number of copies to replicate.
	NumCopies uint32
	// Addr is the address of the local object.
	Addr oid.Address
	// Obj is the object to avoid fetching it from the local storage.
	Obj *objectSDK.Object
	// Nodes is a list of potential object holders.
	Nodes []netmap.NodeInfo
}
